%define build_root %(if [ ! -z ${build_root} ]; then echo ${build_root}; else echo "/var/tmp/IBGD"; fi)
%define STACK_PREFIX %(if [ ! -z ${STACK_PREFIX} ]; then echo ${STACK_PREFIX}; else echo "/usr/local/ibgd"; fi)
%define	name	vmi_mlx
%define	version	2.0.1
%define release 1
%define vmi_tmpdir /tmp/ncsa_vmi
%define krelver %(echo $(uname -r) | tr -s '-' '_')
%define rshcommand rsh
%define autotoolspath    /usr/local/autotools/bin
%define _unpackaged_files_terminate_build 0
%define debug_package %{nil}
%define __check_files %{nil}

# Disable brp-lib64-linux
%ifarch x86_64 ia64
%define __arch_install_post %{nil}
%endif

Summary: VMI %{version}
Name: %{name}
Version: %{version}
Release: %{krelver}
Group: Development/Libraries
License: University of Illinois/NCSA Open Source License Copyright
Source: VMI20.tgz
Distribution: Red Hat Linux
BuildRoot: %{build_root}
Vendor: National Center for Supercomputing Applications & Melanox LTD
BuildRequires: perl 
BuildRequires: autoconf >= 2.52
BuildRequires: automake >= 1.5 
BuildRequires: libtool >= 1.4
Requires: curl >= 7.8
Requires: curl-devel >= 7.8

%ifnarch ia64
BuildArch: %{_target_cpu}
%endif

%description
VMI %{version} is a middleware communication layer that addresses the issues of availability, usability, and management in the context of large-scale SANs interconnected over wide-area grids.

This package contains the base components for VMI %{version}, required both on the head and compute nodes. In addition supported VMI %{version} devices (Infiniband, Myrinet & TCP) are included as well. 

This package contains the development files for VMI %{version}, required for developement and MPI.

%prep

%setup -n VMI20

%install
./install-vmi.sh --build_root $RPM_BUILD_ROOT --prefix %{STACK_PREFIX}

%files
%defattr(-,root,root)
%{STACK_PREFIX}/mpi/ncsa/vmi-2.0.1
/etc/init.d/vmifunctions
/etc/init.d/vmieyes

%clean
\rm -rf ${RPM_BUILD_DIR}/VMI20

%preun

%post

%postun

%changelog
* Wed Aug 4 2004 Pavel Shamis <pasha@mellanox.co.il>
- New spec file
