%define build_root %(if [ ! -z ${build_root} ]; then echo ${build_root}; else echo "/var/tmp/IBGD"; fi)
%define STACK_PREFIX %(if [ ! -z ${STACK_PREFIX} ]; then echo ${STACK_PREFIX}; else echo "/usr/local/ibgd"; fi)
%define VAPI_VER %(if [ ! -z ${VAPI_VER} ]; then echo ${VAPI_VER}; else echo ""; fi)
%define USER_TMPDIR /tmp/ibgd_user
%define KERNEL_TMPDIR /tmp/ibgd_kernel
%define kunamer %(uname -r)
%define VERSION XXXXXX
%define NAME YYYYYY
%define RELVER ZZZZZZ
%define krelver %(echo $(uname -r) | tr -s '-' '_')
%if %(echo -n %{kunamer}| grep -c smp)
 %{expand:%%define ksmp -smp}
%endif

# %if %(echo -n %{kunamer} | cut -c -3 | grep -c "2\.6")
#    %define LIB_MOD_DIR /lib/modules/%{kunamer}/extra/infiniband
# %else
#    %define LIB_MOD_DIR /lib/modules/%{kunamer}/kernel/drivers/infiniband
# %endif

%define LIB_MOD_DIR /lib/modules/%{kunamer}/kernel/drivers/infiniband

%define NETWORK_CONF_DIR /etc/infiniband

# Define Kernel sources path
%define new_src_tree %(if [ -d /lib/modules/%{kunamer}/source/ ]; then echo 1; else echo 0; fi)

%if %new_src_tree
    %define K_SRC /lib/modules/%{kunamer}/source
%else    
    %define K_SRC /lib/modules/%{kunamer}/build
%endif

# Disable debugging
%define debug_package %{nil}
%define __check_files %{nil}

# Disable brp-lib64-linux
%ifarch x86_64 ia64
%define __arch_install_post %{nil}
%endif

Summary: Infiniband HCA Driver
BuildRequires: termcap >= 2.0.8 gcc >= 2.95 glib-devel >= 1.2.10 glibc-devel >= 2.2.4 readline readline-devel ncurses ncurses-devel
Prereq: /sbin/ldconfig, grep
Requires: glib >= 1.2.10 glibc >= 2.2.4
Name: %{NAME}
Version: %{VERSION}
Release: %{krelver}
Copyright: GPL
Group: System Environment/Base
Source: %{NAME}-%{RELVER}.tgz
BuildRoot: %{build_root}
Vendor: Mellanox Technologies Ltd.

%description
Infiniband Upper Layer Protocols package and HCA drivers

%prep
%setup -n %{NAME}-%{RELVER}


%install
rm -rf $RPM_BUILD_ROOT
# Save current direcory
CDIR=`pwd`

# Copy kernel sources to RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/lib/modules/%{kunamer}

# SLES 9 & SuSE 9.1 Updates
if [[ -d "/lib/modules/%{kunamer}/source/" && -e /etc/SuSE-release ]]; then
KSRC=`readlink /lib/modules/%{kunamer}/source`
BSRC=`readlink /lib/modules/%{kunamer}/build`
#install -d $RPM_BUILD_ROOT/usr/src
install -d $RPM_BUILD_ROOT/${KSRC%*/*}
if [ "${BSRC%*/*}" != "${KSRC%*/*}" ]; then
	install -d $RPM_BUILD_ROOT/${BSRC%*/*}
fi

# W/A for kernels from kernel.org which does not have *-obj in /usr/src
#cp -rf ${KSRC}* $RPM_BUILD_ROOT/usr/src
cp -rf ${KSRC}* $RPM_BUILD_ROOT/${KSRC%*/*}
# cp -rf $KSRC-obj $RPM_BUILD_ROOT/usr/src
if [ "${BSRC%*/*}" != "${KSRC%*/*}" ]; then
	cp -rf ${BSRC}* $RPM_BUILD_ROOT/${BSRC%*/*}
fi

ln -snf $RPM_BUILD_ROOT/${KSRC} $RPM_BUILD_ROOT/lib/modules/%{kunamer}/source
ln -snf $RPM_BUILD_ROOT/${BSRC} $RPM_BUILD_ROOT/lib/modules/%{kunamer}/build

else
cp -rf /lib/modules/%{kunamer}/build/ $RPM_BUILD_ROOT/lib/modules/%{kunamer}/
fi

# W/A for Fedora
if [ -f /etc/redhat-release ]; then
   if ( grep -w Fedora /etc/redhat-release > /dev/null ); then
        cd $RPM_BUILD_ROOT/lib/modules/%{kunamer}
	[ ! -d source ] && ln -s build/ source
   fi
fi

cd $CDIR

#Install thca driver (kernel level)
# Define vapi version
if [ "%{VAPI_VER}" == "" ]; then
   if ( /sbin/lspci -n | grep "15b3:6282" > /dev/null ); then #Found Arbel memfree
      VAPI_VER=4.0
   elif ( /sbin/lspci -n | grep -E "15b3:5e8c|15b3:6274" > /dev/null ); then #Found Sinai
	  VAPI_VER=4.0
   else
      if [ `uname -r | cut -c -3` == "2.6" ]; then
        VAPI_VER=4.0
      else
        VAPI_VER=3.2
      fi
   fi
else
	VAPI_VER=%{VAPI_VER}
fi

cd $RPM_BUILD_DIR/%{NAME}-%{RELVER}
	./kernel-install.sh --batch --build_only --tmpdir $RPM_BUILD_ROOT/%{KERNEL_TMPDIR} --ksrc $RPM_BUILD_ROOT/lib/modules/%{kunamer}/build --vapi ${VAPI_VER}
# cd -

# Copy modules
install -d $RPM_BUILD_ROOT/%{LIB_MOD_DIR}
if [ `uname -r | cut -c -3` == "2.6" ]; then
	MODULES=`find $RPM_BUILD_ROOT/%{KERNEL_TMPDIR}/lib/modules/%{kunamer}/extra -name '*.ko' -print`
else
	MODULES=`find $RPM_BUILD_ROOT/%{KERNEL_TMPDIR}/lib/modules/%{kunamer}/kernel/drivers/infiniband -name '*.o' -print`
fi
for mod in $MODULES
do
	install -m 0644 $mod $RPM_BUILD_ROOT/%{LIB_MOD_DIR}
done	


#Install thca driver (user level)
cd $RPM_BUILD_DIR/%{NAME}-%{RELVER}
	./user-install.sh --batch --build_only --prefix $RPM_BUILD_ROOT/%{STACK_PREFIX} --tmpdir $RPM_BUILD_ROOT/%{USER_TMPDIR} --ksrc $RPM_BUILD_ROOT/lib/modules/%{kunamer}/build --vapi ${VAPI_VER}
# cd -
rm -f $RPM_BUILD_ROOT/%{STACK_PREFIX}/driver/infinihost/include/mpga

# Create infiniband configuration
install -d $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}
install -m 0644 $RPM_BUILD_DIR/%{NAME}-%{RELVER}/openib.conf $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}

# Don't load kdapl module by default on 64 bit architecture
%ifarch x86_64 ia64
perl -ni -e  "s@^(KDAPL_LOAD=).*@\${1}no@;print" $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}/openib.conf
%endif

# udapl configuration file
perl -ni -e  "s@/usr/local/ibgd@%{STACK_PREFIX}@;print" $RPM_BUILD_ROOT/%{STACK_PREFIX}/etc/dat.conf
install -m 0644 $RPM_BUILD_ROOT/%{STACK_PREFIX}/etc/dat.conf $RPM_BUILD_ROOT/etc/dat.conf
rm -f $RPM_BUILD_ROOT/%{STACK_PREFIX}/etc/dat.conf

# srp utilities
perl -ni -e "s@/usr/local/ibgd@%{STACK_PREFIX}@;print" $RPM_BUILD_ROOT/%{STACK_PREFIX}/utils/srp_persistent_bind.sh

DEVICES="ib0 ib1"

for DEVICE in $DEVICES
do
if [ -f /etc/SuSE-release ]; then        

cat >> $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}/ifcfg-${DEVICE} << EOF
BOOTPROTO='dhcp'
REMOTE_IPADDR=''
STARTMODE='onboot'
WIRELESS='no'
EOF

else

cat >> $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}/ifcfg-${DEVICE} << EOF
DEVICE=${DEVICE}
BOOTPROTO=dhcp
ONBOOT=no
EOF

fi
done

# Install openib service script
install -d $RPM_BUILD_ROOT/etc/init.d
install -m 0755 $RPM_BUILD_DIR/%{NAME}-%{RELVER}/openibd $RPM_BUILD_ROOT/etc/init.d

%clean
#Remove installed driver after rpm build finished
# Leave $RPM_BUILD_ROOT in order to build dependent packages
#rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{NAME}-%{RELVER}

%pre
# Remove previous installations    
if [ -d %{LIB_MOD_DIR} ]; then
    rm -rf %{LIB_MOD_DIR}
fi

%post
if [ $1 = 1 ]; then #This package is being installed for the first time

	if [ `uname -r` != "%{kunamer}" ]; then
		echo This rpm supports only %{kunamer} kernel...
		rpm -e %{NAME} 
	else
#############################################################################################################
#                                       Modules configuration                                               #
#############################################################################################################
# Define vapi version
if [ "%{VAPI_VER}" == "" ]; then
   if ( /sbin/lspci -n | grep "15b3:6282" > /dev/null ); then #Found Arbel memfree
      VAPI_VER=4.0
   elif ( /sbin/lspci -n | grep -E "15b3:5e8c|15b3:6274" > /dev/null ); then #Found Sinai
	  VAPI_VER=4.0
   else
      if [ `uname -r | cut -c -3` == "2.6" ]; then
        VAPI_VER=4.0
      else
        VAPI_VER=3.2
      fi
   fi
else
        VAPI_VER=%{VAPI_VER}
fi

# Update dat.conf
if ( /sbin/lspci -n | grep "15b3:6282" > /dev/null ); then #Found Arbel memfree
	perl -ni -e  "s@InfiniHost0@InfiniHost_III_Ex0@;print" /etc/dat.conf
fi
if ( /sbin/lspci -n | grep -E "15b3:5e8c|15b3:6274" > /dev/null ); then #Found Sinai
    perl -ni -e  "s@InfiniHost0@InfiniHost_III_Lx0@;print" /etc/dat.conf
fi

   if [ `uname -r | cut -c -3` == "2.6" ]; then
       	# Update /etc/modprobe-openib.conf
       	touch /etc/modprobe-openib.conf
       	perl -ni -e 'if (/\#\# BEGIN OpenIB \#\#$/) { $filter = 1 }' -e 'if (!$filter) { print }' -e 'if (/\#\# END OpenIB \#\#$/){ $filter = 0 }' /etc/modprobe-openib.conf

          if [ "${VAPI_VER}" == "3.2" ]; then
          ######################################### VAPI_VER = 3.2 ############################################



cat >> /etc/modprobe-openib.conf << EOF
## BEGIN OpenIB ##
#
# InfiniBand module loading configuration
#
alias ib0 ib_ipoib
alias ib1 ib_ipoib

alias net-pf-26 ib_sdp
alias kdapl dat_registry
alias kdapltest kdapltest_module

options mod_thh thh_legacy_sqp=0

install mod_vapi /sbin/modprobe -i mod_vapi && %{STACK_PREFIX}/driver/infinihost/bin/open_hcas
install mod_vipkl /sbin/modprobe -i mod_vipkl && %{STACK_PREFIX}/utils/create_devs vipkl
install mosal /sbin/modprobe -i mosal && %{STACK_PREFIX}/utils/create_devs mosal
install ib_ipoib /sbin/modprobe -i ib_ipoib && %{STACK_PREFIX}/utils/update_ipoib_intfs && /sbin/modprobe ib_useraccess && /sbin/modprobe ib_ip2pr
install ib_ip2pr /sbin/modprobe -i ib_ip2pr && %{STACK_PREFIX}/utils/create_devs ib_ip2pr && /sbin/modprobe ib_dapl_srv
install ib_dapl_srv /sbin/modprobe -i ib_dapl_srv && %{STACK_PREFIX}/utils/create_devs ib_udapl && /sbin/modprobe ib_useraccess_cm
install ib_useraccess /sbin/modprobe -i ib_useraccess && %{STACK_PREFIX}/utils/create_devs ib_useraccess
install ib_useraccess_cm /sbin/modprobe -i ib_useraccess_cm && %{STACK_PREFIX}/utils/create_devs ib_useraccess_cm
install ib_sa_client /sbin/modprobe -i ib_sa_client && /sbin/modprobe ib_useraccess
install ib_srp /sbin/modprobe -i ib_srp && { %{STACK_PREFIX}/utils/srp_persistent_bind.sh & }
remove ib_srp %{STACK_PREFIX}/utils/remove_srp_bind_persistent.sh && /sbin/modprobe -r -q --ignore-remove ib_srp
install ib_mad /sbin/modprobe -i ib_mad && /sbin/modprobe ib_tavor
install dat_registry /sbin/modprobe -i dat_registry && /sbin/modprobe ib_kdapl 
install kdapltest_module /sbin/modprobe -i kdapltest_module && %{STACK_PREFIX}/utils/create_devs kdapltest_module
## END OpenIB ##
EOF

          else
          ######################################### VAPI_VER = 4.0 ############################################

                if [ "x$(uname -m)" == "xx86_64" ] && cat /proc/cpuinfo | grep 'AMD' > /dev/null ; then
                        disable_msix=1
                else
                        disable_msix=0
                fi

cat >> /etc/modprobe-openib.conf << EOF
## BEGIN OpenIB ##
#
# InfiniBand module loading configuration
#
alias ib0 ib_ipoib
alias ib1 ib_ipoib

alias net-pf-26 ib_sdp
alias kdapl dat_registry
alias kdapltest kdapltest_module
alias /dev/mosal mlxsys
alias /dev/vipkl mod_vip

options mod_thh disable_msix=${disable_msix}
options mod_rhh disable_msix=${disable_msix}

# mlxsys
install mlxsys /sbin/modprobe -q --ignore-install mlxsys && { rm -f /dev/mosal; mknod /dev/mosal c \`awk '(\$2=="mosal") {print \$1}' /proc/devices\` 33; }
remove mlxsys /sbin/modprobe -r -q --ignore-remove mlxsys && { /bin/rm -f /dev/mosal; }

# mod_vapi
install mod_vip /sbin/modprobe -q --ignore-install mod_vip && { rm -f /dev/vipkl; mknod /dev/vipkl c \`awk '(\$2=="mellanox_vipkl") {print \$1}' /proc/devices\` 1; } && { if ( /sbin/lspci -n | grep -E "15b3:6282|15b3:5e8c|15b3:6274" > /dev/null ); then /sbin/modprobe mod_rhh ;else /sbin/modprobe mod_thh; fi }
remove mod_vip /sbin/modprobe -r -q --ignore-remove mod_vip && { /bin/rm -f /dev/vipkl; }

# mod_thh/mod_rhh
install mod_thh /sbin/modprobe -q --ignore-install mod_thh && open_hcas
remove mod_thh close_hcas ; /sbin/modprobe -r -q --ignore-remove mod_thh
install mod_rhh /sbin/modprobe -q --ignore-install mod_rhh && open_hcas
remove mod_rhh close_hcas ; /sbin/modprobe -r -q --ignore-remove mod_rhh


install ib_ipoib /sbin/modprobe -i ib_ipoib && %{STACK_PREFIX}/utils/update_ipoib_intfs && /sbin/modprobe ib_useraccess && /sbin/modprobe ib_ip2pr
install ib_ip2pr /sbin/modprobe -i ib_ip2pr && %{STACK_PREFIX}/utils/create_devs ib_ip2pr && /sbin/modprobe ib_dapl_srv
install ib_dapl_srv /sbin/modprobe -i ib_dapl_srv && %{STACK_PREFIX}/utils/create_devs ib_udapl && /sbin/modprobe ib_useraccess_cm
install ib_useraccess /sbin/modprobe -i ib_useraccess && %{STACK_PREFIX}/utils/create_devs ib_useraccess
install ib_useraccess_cm /sbin/modprobe -i ib_useraccess_cm && %{STACK_PREFIX}/utils/create_devs ib_useraccess_cm
install ib_sa_client /sbin/modprobe -i ib_sa_client && /sbin/modprobe ib_useraccess
install ib_srp /sbin/modprobe -i ib_srp && { %{STACK_PREFIX}/utils/srp_persistent_bind.sh & }
remove ib_srp %{STACK_PREFIX}/utils/remove_srp_bind_persistent.sh && /sbin/modprobe -r -q --ignore-remove ib_srp
install ib_mad /sbin/modprobe -i ib_mad && /sbin/modprobe ib_tavor
install dat_registry /sbin/modprobe -i dat_registry && /sbin/modprobe ib_kdapl 
install kdapltest_module /sbin/modprobe -i kdapltest_module && %{STACK_PREFIX}/utils/create_devs kdapltest_module
remove ib_tavor /sbin/modprobe -r -q --ignore-remove ib_tavor && { if ( /sbin/lspci -n | grep -E "15b3:6282|15b3:5e8c|15b3:6274" > /dev/null ); then /sbin/modprobe -r mod_rhh ;else /sbin/modprobe -r mod_thh; fi  }
## END OpenIB ##
EOF
            
          fi

          # Add modprobe-openib.conf to the /etc/modprobe.conf
          perl -ni -e "print unless (m@include /etc/modprobe-openib.conf@)" /etc/modprobe.conf
          echo "include /etc/modprobe-openib.conf" >> /etc/modprobe.conf
	  /sbin/depmod -r -ae %{kunamer}

   else # Kernel = 2.4
		# Update /etc/modules-openib.conf
		touch /etc/modules-openib.conf
		perl -ni -e 'if (/\#\# BEGIN OpenIB \#\#$/) { $filter = 1 }' -e 'if (!$filter) { print }' -e 'if (/\#\# END OpenIB \#\#$/){ $filter = 0 }' /etc/modules-openib.conf
			
   
          if [ "${VAPI_VER}" == "3.2" ]; then
          ######################################### VAPI_VER = 3.2 ############################################

cat >> /etc/modules-openib.conf << EOF
## BEGIN OpenIB ##
#
# InfiniBand module loading configuration
#
alias ib0  ib_ipoib 
alias ib1  ib_ipoib

alias net-pf-26 ib_sdp 
options mod_thh thh_legacy_sqp=0
alias kdapl dat_registry
alias kdapltest kdapltest_module

post-install mod_vapi  %{STACK_PREFIX}/driver/infinihost/bin/open_hcas 
post-install mosal %{STACK_PREFIX}/utils/create_devs mosal
post-install mod_vipkl %{STACK_PREFIX}/utils/create_devs vipkl 
post-install ib_useraccess %{STACK_PREFIX}/utils/create_devs ib_useraccess 
post-install ib_ipoib %{STACK_PREFIX}/utils/update_ipoib_intfs 
add above ib_ipoib ib_useraccess
add above ib_ipoib ib_ip2pr 
post-install ib_ip2pr %{STACK_PREFIX}/utils/create_devs ib_ip2pr 
add above ib_ip2pr ib_dapl_srv
post-install ib_dapl_srv %{STACK_PREFIX}/utils/create_devs ib_udapl 
add above ib_dapl_srv ib_useraccess_cm 
post-install ib_useraccess_cm %{STACK_PREFIX}/utils/create_devs ib_useraccess_cm 
post-install ib_srp { %{STACK_PREFIX}/utils/srp_persistent_bind.sh & }
pre-remove ib_srp %{STACK_PREFIX}/utils/remove_srp_bind_persistent.sh 
add above ib_sa_client ib_useraccess 
add below ib_ipoib ib_tavor
post-install dat_registry /sbin/modprobe ib_kdapl 
post-install kdapltest_module %{STACK_PREFIX}/utils/create_devs kdapltest_module
## END OpenIB ##
EOF

          else
          ######################################### VAPI_VER = 4.0 ############################################

cat >> /etc/modules-openib.conf << EOF
## BEGIN OpenIB ##
#
# InfiniBand module loading configuration
#
alias ib0  ib_ipoib 
alias ib1  ib_ipoib

alias net-pf-26 ib_sdp

alias /dev/mosal mlxsys
alias /dev/vipkl mod_vapi
alias kdapl dat_registry
alias kdapltest kdapltest_module

post-install mlxsys { rm -f /dev/mosal; mknod /dev/mosal c \`awk '(\$2=="mosal") {print \$1}' /proc/devices\` 33 ; }
post-remove mlxsys /bin/rm -f /dev/mosal

post-install mod_vip { rm -f /dev/vipkl; mknod /dev/vipkl c \`awk '(\$2=="mellanox_vipkl") {print \$1}' /proc/devices\` 1 ; } && { if ( /sbin/lspci -n | grep -E "15b3:6282|15b3:5e8c|15b3:6274" > /dev/null ); then /sbin/modprobe mod_rhh ;else /sbin/modprobe mod_thh; fi  }
post-remove mod_vip /bin/rm -f /dev/vipkl

post-install mod_thh open_hcas
pre-remove mod_thh close_hcas
post-install mod_rhh open_hcas
pre-remove mod_rhh close_hcas

post-install ib_useraccess %{STACK_PREFIX}/utils/create_devs ib_useraccess 
post-install ib_ipoib %{STACK_PREFIX}/utils/update_ipoib_intfs 
add above ib_ipoib ib_useraccess
add above ib_ipoib ib_ip2pr 
post-install ib_ip2pr %{STACK_PREFIX}/utils/create_devs ib_ip2pr 
add above ib_ip2pr ib_dapl_srv
post-install ib_dapl_srv %{STACK_PREFIX}/utils/create_devs ib_udapl 
add above ib_dapl_srv ib_useraccess_cm 
post-install ib_useraccess_cm %{STACK_PREFIX}/utils/create_devs ib_useraccess_cm 
add above ib_sa_client ib_useraccess 
add below ib_ipoib ib_tavor
post-remove ib_tavor { if ( /sbin/lspci -n | grep -E "15b3:6282|15b3:5e8c|15b3:6274" > /dev/null ); then /sbin/modprobe -r mod_rhh ;else /sbin/modprobe -r mod_thh; fi  }
post-install ib_srp { %{STACK_PREFIX}/utils/srp_persistent_bind.sh & }
pre-remove ib_srp %{STACK_PREFIX}/utils/remove_srp_bind_persistent.sh 
post-install dat_registry /sbin/modprobe ib_kdapl 
post-install kdapltest_module %{STACK_PREFIX}/utils/create_devs kdapltest_module
## END OpenIB ##
EOF
            
          fi

          # Add modules-openib.conf to the /etc/modules.conf
          perl -ni -e "print unless (m@include /etc/modules-openib.conf@)" /etc/modules.conf
          echo "include /etc/modules-openib.conf" >> /etc/modules.conf
	  /sbin/depmod -r -ae -F /boot/System.map-%{kunamer} %{kunamer}

   fi

#############################################################################################################

        
	    # Update /etc/ld.so.conf
	    perl -ni -e "print unless (m@%{STACK_PREFIX}/driver/infinihost/lib@)" /etc/ld.so.conf
	    echo "%{STACK_PREFIX}/driver/infinihost/lib" >> /etc/ld.so.conf
	    perl -ni -e "print unless (m@%{STACK_PREFIX}/lib@)" /etc/ld.so.conf
	    echo "%{STACK_PREFIX}/lib" >> /etc/ld.so.conf
		%ifarch x86_64
	    perl -ni -e "print unless (m@%{STACK_PREFIX}/lib64@)" /etc/ld.so.conf
	    echo "%{STACK_PREFIX}/lib64" >> /etc/ld.so.conf
		%endif
	    /sbin/ldconfig
	  

	    # Create links to bin files from /usr/bin
	    cd /usr/bin
		for bin in %{STACK_PREFIX}/driver/infinihost/bin/*
		do
			ln -s -f ${bin}
		done

        if [ -d %{STACK_PREFIX}/bin ]; then
    		for bin in %{STACK_PREFIX}/bin/*
    		do
    			ln -s -f ${bin}
    		done
        fi    
#	    cd -

# Change IPoIB configuration

if [ -f /etc/redhat-release ]; then
    DISTRIBUTION="RedHat"
elif [ -f /etc/rocks-release ]; then
    DISTRIBUTION="Rocks"
elif [ -f /etc/SuSE-release ]; then
    DISTRIBUTION="SuSE"
else
    DISTRIBUTION=`ls /etc/*-release | head -n 1 | xargs -iXXX basename XXX -release 2> /dev/null`
fi

INTERFACES=`/sbin/ifconfig | grep eth | awk '{print$1}' | sort -n | tr -s '\n' '\ '`
for INTERFACE in $INTERFACES
do
	ADDRS=`/sbin/ifconfig $INTERFACE | grep "inet addr"`
  	if [[ -n $ADDRS ]]; then
	      LAN_INTERFACE=$INTERFACE
	      break
	fi
done

LAN_INTERFACE=${LAN_INTERFACE:-eth0}

DEVICES="ib0 ib1"
high_IP=`/sbin/ifconfig | sed -e "/\($LAN_INTERFACE\).*/{ N; s/.*inet addr:\([0-9]*\).*/\1/; }" | grep ^[0-9] | head -1`
if [ "${high_IP}" == "" ]; then
	high_IP=10
fi	
let high_IP++
low_IP=`/sbin/ifconfig | sed -e "/\($LAN_INTERFACE\).*/{ N; s/.*inet addr:[0-9]*\.\([0-9]*\.[0-9]*\.[0-9]*\).*/\1/; }" | grep ^[0-9] | head -1`
if [ "${low_IP}" == "" ]; then
	low_IP=0.0.1
fi
IPADDR=${high_IP}.${low_IP}

NETMASK=`/sbin/ifconfig | sed -e "/\($LAN_INTERFACE\).*/{ N; s/.*Mask:\([0-9]*\.[0-9]*\.[0-9]*\.[0-9]*\).*/\1/; }" | grep ^[0-9] | head -1`
if [ "${NETMASK}" == "" ]; then
	NETMASK=255.0.0.0
fi
	
low_Bcast=`/sbin/ifconfig | sed -e "/\($LAN_INTERFACE\).*/{ N; s/.*Bcast:[0-9]*\.\([0-9]*\.[0-9]*\.[0-9]*\).*/\1/; }" | grep ^[0-9] | head -1`
if [ "${low_Bcast}" == "" ]; then
	low_Bcast=0.255.255
fi	
BROADCAST=${high_IP}.${low_Bcast}
ONBOOT=1


IP_A=`echo ${IPADDR} | cut -d '.' -f 1 | tr -d [:space:]`
IP_B=`echo ${IPADDR} | cut -d '.' -f 2 | tr -d [:space:]`
IP_C=`echo ${IPADDR} | cut -d '.' -f 3 | tr -d [:space:]`
IP_D=`echo ${IPADDR} | cut -d '.' -f 4 | tr -d [:space:]`

NM_A=`echo ${NETMASK} | cut -d '.' -f 1 | tr -d [:space:]`
NM_B=`echo ${NETMASK} | cut -d '.' -f 2 | tr -d [:space:]`
NM_C=`echo ${NETMASK} | cut -d '.' -f 3 | tr -d [:space:]`
NM_D=`echo ${NETMASK} | cut -d '.' -f 4 | tr -d [:space:]`

NW_A=$[ $IP_A & $NM_A ]
NW_B=$[ $IP_B & $NM_B ]
NW_C=$[ $IP_C & $NM_C ]
NW_D=$[ $IP_D & $NM_D ]

NETWORK=${NW_A}.${NW_B}.${NW_C}.${NW_D}

IP_BCD=${IPADDR#*.}


NET_BCD=${NETWORK#*.}
BR_BCD=${BROADCAST#*.}

for DEVICE in $DEVICES
do
target=%{NETWORK_CONF_DIR}/ifcfg-${DEVICE}
cat $NULL > $target

if [ "$DISTRIBUTION" == "SuSE" ]; then
    echo BOOTPROTO=\'static\' >> $target
    echo IPADDR=\'${IP_A}.${IP_BCD}\' >> $target
    echo NETMASK=\'${NETMASK}\' >> $target
    echo NETWORK=\'${NETWORK}\' >> $target
    echo BROADCAST=\'${IP_A}.${BR_BCD}\' >> $target
    echo REMOTE_IPADDR=\'\' >> $target
    if [ "$ONBOOT" == "1" ]; then
        echo STARTMODE=\'onboot\' >> $target
    else
        echo STARTMODE=\'manual\' >> $target
    fi    
    echo WIRELESS=\'no\' >> $target
else
    echo DEVICE=$DEVICE >> $target
    echo BOOTPROTO=static >> $target
    echo IPADDR=${IP_A}.${IP_BCD} >> $target
    echo NETMASK=${NETMASK} >> $target
    echo NETWORK=${NETWORK} >> $target
    echo BROADCAST=${IP_A}.${BR_BCD} >> $target
    if [ "$ONBOOT" == "1" ]; then
        echo ONBOOT=yes >> $target
    else
        echo ONBOOT=no >> $target    
    fi        
fi

    let IP_A++

done


# Use saved configuration files if exists (rpmsave)
CONFIGS="%{NETWORK_CONF_DIR}/openib.conf %{NETWORK_CONF_DIR}/ifcfg-ib0 %{NETWORK_CONF_DIR}/ifcfg-ib1"
for conf in $CONFIGS
do
    if [ -e ${conf}.rpmsave ]; then
        cp -f ${conf}.rpmsave ${conf}
    fi    
done	


#####################################################################################################

if [[ -f /etc/redhat-release || -f /etc/rocks-release ]]; then        
        /sbin/chkconfig --del openibd 
        /sbin/chkconfig --add openibd 
fi

if [ -f /etc/SuSE-release ]; then
        /sbin/insserv openibd
fi

	fi	
fi		


%files
%defattr(-,root,root)
%dir %{STACK_PREFIX}
#%{STACK_PREFIX}
%{STACK_PREFIX}/driver
%{STACK_PREFIX}/lib
%ifarch x86_64
%{STACK_PREFIX}/lib64
%endif
%{STACK_PREFIX}/bin
%{STACK_PREFIX}/etc
%{STACK_PREFIX}/utils
%{STACK_PREFIX}/src
%{LIB_MOD_DIR}
%{K_SRC}/drivers/infiniband
%dir %{NETWORK_CONF_DIR}
%config /etc/dat.conf
%config %{NETWORK_CONF_DIR}/openib.conf
%config %{NETWORK_CONF_DIR}/ifcfg-ib0
%config %{NETWORK_CONF_DIR}/ifcfg-ib1
/etc/init.d/openibd

%preun
if [ $1 = 0 ]; then  # Erase, not upgrade

   if [[ -f /etc/redhat-release || -f /etc/rocks-release ]]; then        
        /sbin/chkconfig --del openibd 
   fi
   if [ -f /etc/SuSE-release ]; then
        /sbin/insserv -r openibd
   fi

   if [ -d  %{STACK_PREFIX}/driver/infinihost/bin ]; then
     cd %{STACK_PREFIX}/driver/infinihost/bin
     for bin in *
     do
        [ "$bin" != "*" ] && /bin/rm -f /usr/bin/$bin
     done
#     cd -
   fi

   if [ -d  %{STACK_PREFIX}/bin ]; then
     cd %{STACK_PREFIX}/bin
     for bin in *
     do
        [ "$bin" != "*" ] && /bin/rm -f /usr/bin/$bin
     done
#     cd -
   fi

fi


%postun
if [ $1 = 0 ]; then # Erase, not upgrade
# Clean Environment Files

   if (grep -v %{STACK_PREFIX} /etc/ld.so.conf > /tmp/tmp.file.OpenIB); then
        mv -f /tmp/tmp.file.OpenIB /etc/ld.so.conf
   fi
   rm -f /tmp/tmp.file.OpenIB
   /sbin/ldconfig


	if [ `uname -r | cut -c -3` == "2.6" ]; then
	# Clean /etc/modprobe.conf   
	   perl -ni -e "print unless (m@include /etc/modprobe-openib.conf@)" /etc/modprobe.conf
	   rm -f /etc/modprobe-openib.conf
	   /sbin/depmod -r -ae %{kunamer}
	else
	# Clean /etc/modules.conf   
	   perl -ni -e "print unless (m@include /etc/modules-openib.conf@)" /etc/modules.conf
	   rm -f /etc/modules-openib.conf
	   /sbin/depmod -r -ae -F /boot/System.map-%{kunamer} %{kunamer}
	fi

	# Only delete these if this isn't an upgrade
	#  rm -f /dev/vipkl_dev
	#  rm -f /dev/mosal

fi

%changelog
* Sun Jul 11 2004 Vladimir Sokolovsky <vlad@mellanox.co.il>
- Initial packaging
